/*
**    Projet etudiants CPE Lyon
**    Copyright (C) 2012 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/



#ifndef GLWIDGET_HPP
#define GLWIDGET_HPP


#include <QtOpenGL/QGLWidget>
#include <navigator_tool.hpp>
#include <scene.hpp>

class Window;

class glwidget : public QGLWidget
{

    Q_OBJECT

public:

    glwidget(QWidget *parent=0);
    ~glwidget();

    //l'objet scene courant que l'on va utiliser pour la scene 3D
    scene current_scene;

    //un pointeur vers la fenetre Qt
    Window *p_window;

protected:

    //les fonctions OpenGL
    void initializeGL();
    void paintGL();
    void resizeGL(int width, int height);
    void mousePressEvent(QMouseEvent *event);
    void mouseReleaseEvent(QMouseEvent *event);
    void mouseMoveEvent(QMouseEvent *event);
    void keyPressEvent(QKeyEvent *event);


private:

    //le gestionnaire de naviguation 3D
    cpe::navigator_tool nav;

    //affichage d'une aide au lancement du programme
    void print_help_start() const;




};


#endif
