/*
**    Projet etudiants CPE Lyon
**    Copyright (C) 2012 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef OBJET_AFFICHABLE_HPP
#define OBJET_AFFICHABLE_HPP


#include <mesh.hpp>

#include <vector>
#include <string>

class objet_affichable
{
public:
    //constructeur sans arguments
    objet_affichable();
    //constructeur qui vient charger directement un fichier d'un maillage (format .off attendu)
    objet_affichable(const std::string& filename);

    // affiche l'objet 3D a l'ecran
    void affiche() const;

private:

    //stockage interne de la geometrie
    cpe::mesh geometrie;
    //stockage interne des normales de l'objet
    std::vector<double> normales;
};

#endif
