
/*
**    Projet etudiants CPE Lyon
**    Copyright (C) 2012 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef SCENE_HPP
#define SCENE_HPP



#include <objet_affichable.hpp>


class glwidget;

class scene
{
public:

    /** \brief default constructor */
    scene(glwidget* p_glwidget=0);

    /** \brief Method called only once at the beginning (load off files ...) */
    void load_model();
    /** \brief Method called at every frame */
    void draw_scene();

    // permet d'afficher/cacher la texture
    void set_affichage_texture(const bool& est_actif);

private:

    /** \brief pointer to QLWidget */
    glwidget *p_glwidget;

    // methode d'exemple affichant un objet texture
    void affichage_texture_exemple() const;


    //identifiant d'une texture
    int tex;
    //est-ce qu'on affiche la texture
    bool affiche_texture;

    //des objets que l'on peut afficher
    objet_affichable objet_1;
    objet_affichable objet_2;
    objet_affichable objet_3;

};

#endif
